/* Output from p2c, the Pascal-to-C translator */
/* From input file "reton.text" */


#include <p2c/p2c.h>


#ifndef GENERAL_2_H
#include <p2c/general_2.h>
#endif
/* p2c: reton.text, line 7: Warning: Could not find module GRAPHICS [271] */

/*#include "graphics.h"*/

/*homeless orphans*/

#ifndef MISC_H
#include <p2c/misc.h>
#endif

#ifndef WOLCOMPLIB_H
#include <wolcomp.h>
#endif

#ifndef WOLCOMPII_H
#include <wolcompii.h>
#endif


#define plotter         705


/******************************************/
/*********** main program ***********/

main(argc, argv)
int argc;
Char *argv[];
{  /*main program*/
  long i;   /*index of current row*/
  long j, k, x2, y2, x3, y3, x4, y4, x5, y5, nrows, ncols;
  int topheight,botheight,leftwidth
    ,rightwidth,pixelheight,pixelwidth
      ,hexspace,rows,columns,height,width;
  char c;

  char libfile[100];

  lambda=100;

  PASCAL_MAIN(argc, argv);
  wolcomp_init(lambda);

  sprintf(libfile,"%s.wolcif",argv[0]);
  load_library(libfile);

  lambda=100;

  topheight=cell_height("topcell")+cell_height("nwpads");
  botheight=cell_height("botcell");
  leftwidth=cell_width("leftcell")+cell_width("vext");
  rightwidth=cell_width("rightcell")+(cell_width("espads"));
  pixelheight=cell_height("pixel");
  pixelwidth=cell_width("pixel");
  hexspace=cell_width("evenrowend");

  printf("topheight %d, botheight %d\n\
    leftwidth %d, rightwidth %d\n\
    pixelheight %d, pixelwidth %d\n\
    hexspace %d\n",
    topheight,botheight,
    leftwidth,rightwidth,
    pixelheight,pixelwidth,
    hexspace);



  printf("specify # rows and columns (n) or chip size (s)? ");
  c=getchar();


  if(c=='s'){

    printf("desired width of chip (lambda)? ");
    scanf("%d",&width);
    printf("desired height of chip (lambda)? ");
    scanf("%d",&height);
    getchar();
    
    rows=2*(2*height-topheight-botheight)/(pixelheight*2);
    columns=(2*width-leftwidth-rightwidth-hexspace)/pixelwidth;

    nrows=rows;
    ncols=columns;

    printf("%d rows, %d columns\n",rows,columns);
  }else{
    printf("Nrows = ");
    scanf("%ld%*[^\n]", &nrows);
    getchar();
    printf("Ncols = ");
    scanf("%ld%*[^\n]", &ncols);
    getchar();
  }

  define_cell("bot");
  hcompose();
  make_array("botcell", ncols);
  place("sense");
  endef();

  define_cell("top");
  hcompose();
  place("topleft");
  make_array("topcell", ncols);
  place("topright");
  endef();

  define_cell("right");
  vcompose();
  make_array("rightcell", nrows);
  endef();

  define_cell("left");
  vcompose();
  make_array("leftcell", nrows);
  endef();

  define_cell("oddrow");
  hcompose();
  transform(MX);
  make_array("pixel",ncols);
  transform(R0);
  place("oddrowend");
  endef();

  define_cell("evenrow");
  hcompose();
  place("evenrowend");
  make_array("pixel",ncols);
  endef();


  define_cell("rowpair");
  vcompose();
  place("oddrow");
  place("evenrow");
  endef();

  define_cell("core");
  vcompose();
  make_array("rowpair", nrows/2);
  endef();

  define_cell("lcrt");
  nocompose();
  draw(cell("left"));
  x0 = x1;
  draw(cell("core"));
  x0 = x1;
  draw(cell("right"));
  x0 = 0;
  y0_ = y1_;
  draw(cell("top"));
  y0_ = y1_;
  endef();


  define_cell("framed");
  nocompose();
  place("clkdly");
  x0=x1;
  place("bot");            /* put bot to right of clkdly */
  y0_ = y1_;
  x0=x0-cell_width("left");
  place("lcrt");           /* put lcrt above bot nestled to left against clkdly*/
  x0 = 0;
  y0_ = y1_ - cell_height("vext");  /* attach vext to upper left */
  place("vext");
  endef();

  define_cell("chip");
  nocompose();
  x2 = cell_width("framed");
  y2 = cell_height("framed");  /* save size of framed */

  place("framed");

  y0_ = cell_height("clkdly");
  place("wspads");

  y0_ = y2 - cell_height("wnpads") - cell_height("vext");
  place("wnpads");

  x0 = x2;
  y0_ = 0;
  place("espads");

/* dont have these anymore ********************
  x0 = x2 - cell_width("sepads") + cell_width("videosd2pad");
  y0_ = -cell_height("sepads");
  place("sepads");
***********************************************/

  /**x0:=x2; y0:=y2-cell_height('enpads'); **/
  /*** place('enpads');  ***/

  x0 = x2 - cell_width("nepads");
  y0_ = y2;
  place("nepads");

  x0 = cell_width("vext");
  y0_ = y2;
  place("nwpads");

  endef();

  printf("chip size: %d wide by %d high\n",
	 cell_width("chip")/2,cell_height("chip")/2);

  printf("leftover space: %d horizontally, %d vertically\n",
	 (2*width-cell_width("chip"))/2,(2*height-cell_height("chip"))/2);

  x0=0;
  y0_=0;

/* for extracting purposes */

/*
define_cell("test");
hcompose();
place("clkdly");
place("botcell");
place("botcell");
place("botcell");
place("sense");
x0=cell_width("clkdly")-cell_width("leftcell");
y0_=cell_height("botcell");
place("leftcell");
place("pixel");
place("pixel");
place("pixel");
place("oddrowend");
place("rightcell");
x0=cell_width("clkdly")-cell_width("leftcell");
y0_=y0_+cell_height("pixel");
place("leftcell");
place("evenrowend");
transform(MX);
place("pixel");
place("pixel");
place("pixel");
transform(R0);
place("rightcell");
x0=cell_width("clkdly")-cell_width("leftcell");
y0_=y0_+cell_height("pixel");
place("leftcell");
place("pixel");
place("pixel");
place("pixel");
place("oddrowend");
place("rightcell");
x0=cell_width("vext");
y0_=y0_+cell_height("pixel")+cell_height("topcell")-cell_height("vext");
place("vext");
place("topleft");
place("topcell");
place("topcell");
place("topcell");
place("topright");
endef();
*/





  nocompose();
  place("chip");

  shut_down();
  exit(EXIT_SUCCESS);
}

/* End. */








